#	include	"mosslib.h"

#	include	<stdarg.h>

#ifdef	MOSS_DEV
#include	<signal.h>
#include	<sys/time.h>

static	int			the_freq;
static	void		*the_func = NULL;

struct	timeval		old_tv;

void	moss_timer(int the_signal)
	{
	struct	timeval	new_tv;
	struct	itimerval	itv, itv1;
	void	(*func)(int);
	int	useconds;

	if(!the_func)
		return;
	func = the_func;
	gettimeofday(&new_tv, NULL);
	useconds = (new_tv.tv_sec - old_tv.tv_sec)*1000000 +
		(new_tv.tv_usec - old_tv.tv_usec);
	old_tv.tv_sec = new_tv.tv_sec;
	old_tv.tv_usec = new_tv.tv_usec;

	itv.it_interval.tv_sec = 0;
	itv.it_interval.tv_usec = 0;
	itv.it_value.tv_sec = 0;
	itv.it_value.tv_usec = 0;
	setitimer(ITIMER_VIRTUAL, &itv, &itv1);

	func(useconds);

	signal(SIGVTALRM, moss_timer);

	itv.it_interval.tv_sec = 0;
	itv.it_interval.tv_usec = 10000/the_freq;
	itv.it_value.tv_sec = 0;
	itv.it_value.tv_usec = 10000/the_freq;
	setitimer(ITIMER_VIRTUAL, &itv, &itv1);
	}

int	pump_up_the_volume(
	int		onoff,
	int		freq)
	{
	signal(SIGVTALRM, moss_timer);
	if(onoff == 1)	/* turn on */
		{
		struct	itimerval	itv, itv1;

		the_freq = freq;
		itv.it_interval.tv_sec = 0;
		itv.it_interval.tv_usec = 10000/freq;
		itv.it_value.tv_sec = 0;
		itv.it_value.tv_usec = 10000/freq;
		gettimeofday(&old_tv, NULL);
		if(setitimer(ITIMER_VIRTUAL, &itv, &itv1)<0)
			perror("mosslib: setitimer: ");
		}
	else
		{
		struct	itimerval	itv, itv1;

		itv.it_interval.tv_sec = 0;
		itv.it_interval.tv_usec = 0;
		itv.it_value.tv_sec = 0;
		itv.it_value.tv_usec = 0;
		if(setitimer(ITIMER_VIRTUAL, &itv, &itv1) <0)
			perror("mosslib: setitimer: ");
		}
	return(0);
	}

int	install_sim_thread(
	void		*simfunc,
	void		*notused)
	{
	the_func = simfunc;
	return(0);
	}

#else

_syscall2(int, install_sim_thread, void *, fff, void *, sss)
_syscall2(int, pump_up_the_volume, int, vvv, int, fff)
_syscall3(int, set_defect_rate, int, rrr, int, mmm, int, aaa)
#endif

static	int		moss_output_i = 0;
static	char	moss_output[MAX_MOSS_OUTPUT];
static	char	t_moss_output[MAX_MOSS_OUTPUT];

/* output functions.  Some output can be lost, but that is just the way
 * it is.
 * remember: moss functions may not make any system calls!  Certain
 * death to any that do.
 */
int	moss_printf(
	char	*fmtstr,
	...)
	{
	int		i;
	va_list	ap;

	va_start(ap, fmtstr);
	vsprintf(t_moss_output, fmtstr, ap);
	va_end(ap);
	i = strlen(t_moss_output);
	if((i+moss_output_i+1) > MAX_MOSS_OUTPUT)
		return(-1);
	strcpy(&moss_output[moss_output_i], t_moss_output);
	moss_output_i += i;
	return(0);
	}

/* Only call this function from the main-thread of execution.  Good to
 * put a wait loop, etc.
 */
int	moss_flush()
	{
	if(moss_output_i)
		{
		printf("%s", moss_output);
		fflush(stdout);
		}
	moss_output_i = 0;
	return(0);
	}


